import AssetsSource from "./AssetsSource";
import { Config, AssetSourceOptions } from "../util/Options";
import { SassImplementation } from "../util/SassImplementation";
export default class AssetsCollection {
    options: Config;
    sass: SassImplementation;
    sources: Array<AssetsSource>;
    constructor(options: Config);
    /**
      * adds an AssetsSource to the collection
      * @param    {String} src - the source directory of the assets
      * @param    {Object} opts - the options to pass @see AssetsSource
      * @returns  {AssetsCollection} returns the instance of AssetsCollection for chaining
      */
    addSource(src: string, opts: Partial<AssetSourceOptions>): AssetsCollection;
    /**
      * returns the scss to register all the assets
      * @param    {String} name - the namespace to use
      * @returns  {String} the scss representation of the asset registration
      */
    asAssetImport(name: string | undefined): string;
    /**
      * Build a string suitable for caching an instance of this
      * @returns {String} the cache key
      */
    cacheKey(name: string): string;
}
//# sourceMappingURL=AssetsCollection.d.ts.map