/**
  * provides an interface for expanding a given URI to valid import locations
  *
  * @constructor
  * @param   {String} uri - the base URI to be expanded
  */
export declare class NameExpander {
    uri: string;
    _possibleFiles: Set<string>;
    locations: Array<string>;
    constructor(uri: string);
    get files(): Set<string>;
    /**
      * given a location, expands the collection of possible file imports
      *
      * @param   {String} location - the location path the expand the URI against
      */
    addLocation(location: string): void;
    private calculatePossibleFiles;
}
//# sourceMappingURL=NameExpander.d.ts.map